#ifndef MPC_DEM_TTT_STRUCT_H
#define MPC_DEM_TTT_STRUCT_H

/* #include <MPC/mpc-gen.hpp> */

/***********************************************************************/
/* DEM treatment mode / status */

/* #define DEM_TTT_STOPPED 0 */
/* #define DISTMAP_BUILDING_STARTED 1 */


/***********************************************************************/
/* Distance to obstacles map */

typedef struct POS_CELL_XY
{
  int x;
  int y;
} POS_CELL_XY;

#define DISTMAP_X_MAXSIZE 250
#define DISTMAP_Y_MAXSIZE 250

typedef struct DIST_OBS_MAP
{
  int dimX;
  int dimY;
  float xOrigin;
  float yOrigin;
  float xScale;
  float yScale;
  int cellState[DISTMAP_X_MAXSIZE][DISTMAP_Y_MAXSIZE];
  POS_CELL_XY dist[DISTMAP_X_MAXSIZE][DISTMAP_Y_MAXSIZE];
/*   POS_CELL_XY near[DISTMAP_X_MAXSIZE][DISTMAP_Y_MAXSIZE]; */
  float thresSlope;
  float thresVarSlope;
  float safeDist;
  float padding;
} DIST_OBS_MAP;


/***********************************************************************/
/**************************** Requests I/O *****************************/
/***********************************************************************/

/***********************************************************************/
/* Initialization parameters */

typedef struct DT_INIT_I
{
  char demPoster[256];
} DT_INIT_I;

/***********************************************************************/
/* Build_DistMap parameters */

typedef struct BUILD_DISTMAP_I
{
  float slopeMapDist;
  float thresSlope;
  float thresVarSlope;
  float safeDist;
  int unkwnIsObs;

} BUILD_DISTMAP_I;

/***********************************************************************/
/* Merge_DEMLog parameters */

typedef struct MERGE_DEMLOG_I
{
  char filename[256];
} MERGE_DEMLOG_I;

/***********************************************************************/
/* Save_DEM parameters */

typedef struct SAVE_DEM_I
{
  char filename[256];
} SAVE_DEM_I;


#endif /* MPC_DEM_TTT_STRUCT_H */
